#define  USE_HY11P54
/**************************************************************************************************|
|* Copyright 2018 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11P54sfr.h>    // Peripheral Register Memory Mapping
#include <LCD.h>
#include <LVD.h>
#include <INT.h>
#include <BIE.h>
#include <ADC.h>
/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/
unsigned char WR5WORDBIEDATA(
							unsigned char	BIE_AddrLset,
							unsigned char	BIE_DataHset,
							unsigned char	BIE_DataLset,
							unsigned char (*delay2ms)(void))
{
		unsigned char	BIERLCBUF;	
		unsigned char	BIERLCCNT;	
		unsigned char	REWRCNT;		
		unsigned char	MCKCN2SAVE;
		MCKCN2SAVE=MCKCN2;
		MCKCN2=0x00;

		INT_GIE_Disable();
		ADC_Disable();
		LVD_Open(LVDCN_VLDX_2V91);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_ON);
		delay2ms();
		BIE_AddrL(BIE_AddrLset);
		BIE_DataH(0xff);	
		BIE_DataL(BIE_DataLset);

		if(LVD_GetStatus())	
			goto	FAILLOOP;
	  if(!BIECTRLA_VPPHIGH_GetStatus())	
			goto	FAILLOOP;

		for(REWRCNT=0;REWRCNT<12;REWRCNT++)	
		{
					BIERLCBUF=0xff;
					for(BIERLCCNT=1;BIERLCCNT<=8;BIERLCCNT++)	
					{
						BIERLCBUF=BIERLCBUF<<1;
						BIE_DataL(((BIE_DataLset & (~BIERLCBUF)) | BIERLCBUF));
						BIE_WriteConfig(BIECTRLA_BIEWR_WRITABLE);
						delay2ms();
						BIEPTRLA = (BIEPTRLA -1);	
					}

					BIERLCBUF=0xff;
					for(BIERLCCNT=1;BIERLCCNT<=8;BIERLCCNT++)	
					{
						BIERLCBUF=BIERLCBUF<<1;
						BIE_DataH((BIE_DataHset & (~BIERLCBUF)) | BIERLCBUF);;
						BIE_WriteConfig(BIECTRLA_BIEWR_WRITABLE);
						delay2ms();
						BIEPTRLA = (BIEPTRLA -1);	
					}
		}
		BIEPTRLA = (BIEPTRLA +1);
		LVD_Open(LVDCN_VLDX_LVDOFF);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_OFF);	
		MCKCN2=MCKCN2SAVE;
		return 0;

	FAILLOOP:
		LVD_Open(LVDCN_VLDX_LVDOFF);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_OFF);	
		MCKCN2=MCKCN2SAVE;
		return 1;										
}

unsigned char HY11P54BLVBIEWORD(
							unsigned char	BIE_AddrLset,
							unsigned char	BIE_DataHset,
							unsigned char	BIE_DataLset,
							unsigned char (*delay2ms)(void))
{
		unsigned char	BIERLCBUF;	
		unsigned char	BIERLCCNT;	
		unsigned char	REWRCNT;
		unsigned char	MCKCN2SAVE;
		unsigned char	LCDCN1SAVE;
		unsigned char	i;
		MCKCN2SAVE=MCKCN2;
		LCDCN1SAVE=LCDCN1;
		MCKCN2=0x00;
		LCD_DisplayOff();
		LCDCN1|=LCDCN1_ENLCD_ENABLE + LCDCN1_LCDPR_INTERNAL + LCDCN1_LCDBF_ENABLE +LCDCN1_LCDBI_BIAS;
		for(i=0;i<10;i++)
			delay2ms();
		INT_GIE_Disable();
		ADC_Disable();
		LVD_Open(LVDCN_VLDX_2V61);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_ON);
		for(i=0;i<10;i++)
			delay2ms();
		BIE_AddrL(BIE_AddrLset);
		BIE_DataH(0xff);	
		BIE_DataL(BIE_DataLset);

		if(LVD_GetStatus())	
			goto	FAILLOOP;
	  if(!BIECTRLA_VPPHIGH_GetStatus())	
			goto	FAILLOOP;

					BIERLCBUF=0xff;
					for(BIERLCCNT=1;BIERLCCNT<=8;BIERLCCNT++)	
					{
						BIERLCBUF=BIERLCBUF<<1;
						BIE_DataL(((BIE_DataLset & (~BIERLCBUF)) | BIERLCBUF));
						BIE_WriteConfig(BIECTRLA_BIEWR_WRITABLE);
						delay2ms();
						delay2ms();
						BIEPTRLA = (BIEPTRLA -1);	
					}

					BIERLCBUF=0xff;
					for(BIERLCCNT=1;BIERLCCNT<=8;BIERLCCNT++)	
					{
						BIERLCBUF=BIERLCBUF<<1;
						BIE_DataH((BIE_DataHset & (~BIERLCBUF)) | BIERLCBUF);;
						BIE_WriteConfig(BIECTRLA_BIEWR_WRITABLE);
						delay2ms();
						delay2ms();
						BIEPTRLA = (BIEPTRLA -1);	
					}
		BIEPTRLA = (BIEPTRLA +1);
		LVD_Open(LVDCN_VLDX_LVDOFF);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_OFF);	
		MCKCN2=MCKCN2SAVE;
		LCDCN1=LCDCN1SAVE;
		LCD_DisplayOn();
		return 0;

	FAILLOOP:
		LVD_Open(LVDCN_VLDX_LVDOFF);	
		BIE_EnBiePMP(PWRCN_ENBIEPMP_OFF);	
		MCKCN2=MCKCN2SAVE;
		LCDCN1=LCDCN1SAVE;
		LCD_DisplayOn();
		return 1;										
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
