/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/
#include <GPIO.h>

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// MCKCN1 //
#define MCKCN1_ENHAO              0
#define MCKCN1_ENHAO_MSK         (1 << MCKCN1_ENHAO)
#define MCKCN1_ENHAO_ENABLE      (1 << MCKCN1_ENHAO)
#define MCKCN1_ENHAO_DISABLE     (0 << MCKCN1_ENHAO)

#define MCKCN1_ENXT               1
#define MCKCN1_ENXT_MSK          (1 << MCKCN1_ENXT)
#define MCKCN1_ENXT_ENABLE       (1 << MCKCN1_ENXT)
#define MCKCN1_ENXT_DISABLE      (0 << MCKCN1_ENXT)

#define MCKCN1_XTSP               2
#define MCKCN1_XTSP_MSK          (1 << MCKCN1_XTSP)
#define MCKCN1_XTSP_XTS          (1 << MCKCN1_XTSP)
#define MCKCN1_XTSP_XTL          (0 << MCKCN1_XTSP)

// Reserved XTHSP                 3
// Reserved XTHSP _MSK            1

#define MCKCN1_ADCCK              4
#define MCKCN1_ADCCK_MSK         (1 << MCKCN1_ADCCK)
#define MCKCN1_ADCCK_LSCK        (1 << MCKCN1_ADCCK)
#define MCKCN1_ADCCK_HSDCK       (0 << MCKCN1_ADCCK)

#define MCKCN1_ADCS               5
#define MCKCN1_ADCS_MSK          (7 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV128       (7 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV64        (6 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV32        (5 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV16        (4 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV8         (3 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV4         (2 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV2         (1 << MCKCN1_ADCS)
#define MCKCN1_ADCS_DIV1         (0 << MCKCN1_ADCS)

// MCKCN2 //
#define MCKCN2_CPUCK              0
#define MCKCN2_CPUCK_MSK         (3 << MCKCN2_CPUCK)
#define MCKCN2_CPUCK_HSCK        (3 << MCKCN2_CPUCK)
#define MCKCN2_CPUCK_LSCK        (2 << MCKCN2_CPUCK)
#define MCKCN2_CPUCK_HSDCK       (1 << MCKCN2_CPUCK)
#define MCKCN2_CPUCK_HSSCK       (0 << MCKCN2_CPUCK)

#define MCKCN2_HSS                2
#define MCKCN2_HSS_MSK           (3 << MCKCN2_HSS)
#define MCKCN2_HSS_HSCKDIV8      (3 << MCKCN2_HSS)
#define MCKCN2_HSS_HSCKDIV4      (2 << MCKCN2_HSS)
#define MCKCN2_HSS_HSCKDIV2      (1 << MCKCN2_HSS)
#define MCKCN2_HSS_HSCKDIV1      (0 << MCKCN2_HSS)

#define MCKCN2_HSCK               4
#define MCKCN2_HSCK_MSK          (1 << MCKCN2_HSCK)
#define MCKCN2_HSCK_CY           (1 << MCKCN2_HSCK)
#define MCKCN2_HSCK_HAO          (0 << MCKCN2_HSCK)

#define MCKCN2_LSCK               5
#define MCKCN2_LSCK_MSK          (1 << MCKCN2_LSCK)
#define MCKCN2_LSCK_CY           (1 << MCKCN2_LSCK)
#define MCKCN2_LSCK_LPO          (0 << MCKCN2_LSCK)

// MCKCN3 //
#define MCKCN3_BZS                0
#define MCKCN3_BZS_MSK           (7 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV128   (7 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV64    (6 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV32    (5 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV16    (4 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV8     (3 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV4     (2 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV3     (1 << MCKCN3_BZS)
#define MCKCN3_BZS_PERCKDIV1     (0 << MCKCN3_BZS)

#define MCKCN3_PERCK              3
#define MCKCN3_PERCK_MSK         (1 << MCKCN3_PERCK)
#define MCKCN3_PERCK_HSDCKDIV32  (1 << MCKCN3_PERCK)
#define MCKCN3_PERCK_LSCK        (0 << MCKCN3_PERCK)

#define MCKCN3_LCDS               5
#define MCKCN3_LCDS_MSK          (7 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV128 (7 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV64  (6 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV32  (5 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV16  (4 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV8   (3 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV4   (2 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV2   (1 << MCKCN3_LCDS)
#define MCKCN3_LCDS_PERACKDIV1   (0 << MCKCN3_LCDS)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
//CLK Config function for Peripherals were placed in each peripheral module individually
//CLK Config for MCU(System Clock)were declared/defined below

// Ext Oscillator //
#define CLK_ExtHSCKEnable()             (MCKCN1 |= (MCKCN1_ENXT_ENABLE | MCKCN1_XTSP_XTS))
#define CLK_ExtLSCKEnable()             (MCKCN1 = ((MCKCN1 &(~MCKCN1_XTSP_MSK))|(MCKCN1_ENXT_ENABLE)))// error: the more "=",and need modre ")" 20170721
#define CLK_ExtCKDisable()              (MCKCN1 &= (~(MCKCN1_ENXT_MSK | MCKCN1_XTSP_MSK))) //error : need for")"
#define CLK_ExtHSCkSelect()             (MCKCN2 |= MCKCN2_HSCK_CY)   //**Constraint** Mind that HSCK be Selected after Ext Oscillator is Stable
#define CLK_ExtLSCkSelect()             (MCKCN2 |= MCKCN2_LSCK_CY)   //**Constraint** Mind that LSCK be Selected after Ext Oscillator is Stable

// Internal Oscillator //
#define CLK_HAOEnable()                 (MCKCN1 |= MCKCN1_ENHAO_ENABLE)
#define CLK_HAODisable()                (MCKCN1 &= (~MCKCN1_ENHAO_MSK)) //**Constraint** Make sure that CPUCK IS LSCK or Ext. HSCK
#define CLK_HAOHSCkSel()                (MCKCN2 &= (~MCKCN2_HSCK_MSK))  // HSCK is HAO as default
#define CLK_LPOHSCkSel()                (MCKCN2 &= (~MCKCN2_LSCK_MSK))  // LSCK is LPO as default

// CPUCK Selection //
#define CLK_CPUCKSel(hssdiv,cpucksel)   (MCKCN2 = (MCKCN2 &(~(MCKCN2_HSS_MSK | MCKCN2_CPUCK_MSK))) | hssdiv | cpucksel)//error:the more "=",and change "MCKCN" FOR "MCKCN2| 20170721

// PERCK Selection //
#define CLK_PERCKHSDCKSel()             (MCKCN3 |= MCKCN3_PERCK_HSDCKDIV32)
#define CLK_PERCKLSCKSel()              (MCKCN3 &= (~MCKCN3_PERCK_MSK))

// LCDCK Selection //                   //Prescaler of LCD peripheral operating frequency
#define CLK_LCDCKSel(LCDCKSel)          (MCKCN3 = ((MCKCN3 & (~MCKCN3_LCDS_MSK)) | LCDCKSel))

// BuzzerCK Selection //
#define CLK_BZCKSel(BZCKSel)            (MCKCN3 = ((MCKCN3 & (~MCKCN3_BZS_MSK)) | BZCKSel))

// BuzzerCK Selection //
#define CLK_ADCCKDivSel(ADCDivSel)      (MCKCN1 = ((MCKCN1 & (~MCKCN1_ADCS_MSK)) | ADCDivSel))
#define CLK_ADCCKSel(ADCCKSel)          (MCKCN1 = ((MCKCN1 & (~MCKCN1_ADCCK_MSK)) | ADCCKSel))

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/

//! @name    CLK_GPIO_Mux
//! @brief   Configure GPIO Port to Peripheral usage.
//!          Using when PT2.0 or PT2.1 was config as GPIO,that is, Input Pull High or Output Mode
//! @param   None
//! @return  None
// GPIO Multiplexing //
void CLK_GPIO_Mux();
//! @name    CLK_CPUCKInit
//! @brief   Reset CPU CLK as Default status and Configure it as required
//! @param   CPUCKSel:
//! @param   ExtCKEn:
//! @param   SSCKDiv:
//! @return  None
  //void CLK_CPUCKOpen(unsigned char CPUCKSel,unsigned char ExtCKEn,unsigned char HSSCKDiv);
//void CLK_CPUCKDeinit();
void CLK_CPUCKOpen(
unsigned char CPUCKSel,
unsigned char ExtCKEn,
unsigned char HSSCKDiv,
unsigned char VXTSP,
unsigned char oscSOURCE);