/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/
#include <INT.h>           // Interrupt Config for GPIO

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// PT1 //   MUX: GPIO-DI(PT1.0-PT1.3) / GPIO-DIO(PT1.4~PT1.7) / CPA-AI / LVD-AI / SPI / EUART / BUZZER-DO
#define PT1_PT10                         0
#define PT1_PT10_MSK                    (1 << PT1_PT10)
#define PT1_PT10_H                      (1 << PT1_PT10)
#define PT1_PT10_L                      (1 << PT1_PT10)//(0 << PT1_PT10)modify 20210810

#define PT1_PT11                         1
#define PT1_PT11_MSK                    (1 << PT1_PT11)
#define PT1_PT11_H                      (1 << PT1_PT11)
#define PT1_PT11_L                      (1 << PT1_PT11)//(0 << PT1_PT11)modify 20210810

#define PT1_PT12                         2
#define PT1_PT12_MSK                    (1 << PT1_PT12)
#define PT1_PT12_H                      (1 << PT1_PT12)
#define PT1_PT12_L                      (1 << PT1_PT12)//(0 << PT1_PT11)modify 20210810

#define PT1_PT13                         3
#define PT1_PT13_MSK                    (1 << PT1_PT13)
#define PT1_PT13_H                      (1 << PT1_PT13)
#define PT1_PT13_L                      (1 << PT1_PT13)//(0 << PT1_PT11)modify 20210810

#define PT1_PT14                         4
#define PT1_PT14_MSK                    (1 << PT1_PT14)
#define PT1_PT14_H                      (1 << PT1_PT14)
#define PT1_PT14_L                      (1 << PT1_PT14)//(0 << PT1_PT14)modify 20180827

#define PT1_PT15                         5
#define PT1_PT15_MSK                    (1 << PT1_PT15)
#define PT1_PT15_H                      (1 << PT1_PT15)
#define PT1_PT15_L                      (1<< PT1_PT15)//(0<< PT1_PT15)modify 20180827

#define PT1_PT16                         6
#define PT1_PT16_MSK                    (1 << PT1_PT16)
#define PT1_PT16_H                      (1 << PT1_PT16)
#define PT1_PT16_L                      (1 << PT1_PT16)//(0<< PT1_PT16)modify 20180827

#define PT1_PT17                         7
#define PT1_PT17_MSK                    (1 << PT1_PT17)
#define PT1_PT17_H                      (1 << PT1_PT17)
#define PT1_PT17_L                      (1 << PT1_PT17)//(0 << PT1_PT17)/modify 20180827

// TRISC1 //
#define TRISC1_RSV                       0
#define TRISC1_RSV_MSK                  (15 << TRISC1_RSV)
#define TRISC1_TC14                      4
#define TRISC1_TC14_MSK                 (1 << TRISC1_TC14)
#define TRISC1_TC14_OUTPUT              (1 << TRISC1_TC14)
#define TRISC1_TC14_INPUT               (1 << TRISC1_TC14)//(0 << TRISC1_TC14)/modify 20210810

#define TRISC1_TC15                      5
#define TRISC1_TC15_MSK                 (1 << TRISC1_TC15)
#define TRISC1_TC15_OUTPUT              (1 << TRISC1_TC15)
#define TRISC1_TC15_INPUT               (1 << TRISC1_TC15)//(0 << TRISC1_TC15)/modify 20210810

#define TRISC1_TC16                      6
#define TRISC1_TC16_MSK                 (1 << TRISC1_TC16)
#define TRISC1_TC16_OUTPUT              (1 << TRISC1_TC16)
#define TRISC1_TC16_INPUT               (1 << TRISC1_TC16)//(0 << TRISC1_TC16)/modify 20210810

#define TRISC1_TC17                      7
#define TRISC1_TC17_MSK                 (1 << TRISC1_TC17)
#define TRISC1_TC17_OUTPUT              (1 << TRISC1_TC17)
#define TRISC1_TC17_INPUT               (1 << TRISC1_TC17)//(0 << TRISC1_TC17)/modify 20210810

// PT1DA //
#define PT1DA_DA10                       0
#define PT1DA_DA10_MSK                  (1 << PT1DA_DA10)
#define PT1DA_DA10_CPAI6                (1 << PT1DA_DA10)
#define PT1DA_DA10_DIG                  (1 << PT1DA_DA10)//(0 << PT1DA_DA10)/modify 20210810

#define PT1DA_DA11                       1
#define PT1DA_DA11_MSK                  (1 << PT1DA_DA11)
#define PT1DA_DA11_CPAI7                (1 << PT1DA_DA11)
#define PT1DA_DA11_DIG                  (1 << PT1DA_DA11)//(0 << PT1DA_DA11)/modify 20210810

#define PT1DA_DA12                       2
#define PT1DA_DA12_MSK                  (1 << PT1DA_DA12)
#define PT1DA_DA12_LVDIN                (1 << PT1DA_DA12)
#define PT1DA_DA12_DIG                  (1 << PT1DA_DA12)//(0 << PT1DA_DA12)/modify 20210810

// PT1PU //
#define PT1PU_PU10                       0
#define PT1PU_PU10_MSK                  (1 << PT1PU_PU10)
#define PT1PU_PU10_ENABLE               (1 << PT1PU_PU10)
#define PT1PU_PU10_DISABLE              (1 << PT1PU_PU10)//(0 << PT1PU_PU10)/modify 20210810

#define PT1PU_PU11                       1
#define PT1PU_PU11_MSK                  (1 << PT1PU_PU11)
#define PT1PU_PU11_ENABLE               (1 << PT1PU_PU11)
#define PT1PU_PU11_DISABLE              (1 << PT1PU_PU11)//(0 << PT1PU_PU11)/modify 20210810

#define PT1PU_PU12                       2
#define PT1PU_PU12_MSK                  (1 << PT1PU_PU12)
#define PT1PU_PU12_ENABLE               (1 << PT1PU_PU12)
#define PT1PU_PU12_DISABLE              (1 << PT1PU_PU12)//(0 << PT1PU_PU12)/modify 20210810

#define PT1PU_PU13                       3
#define PT1PU_PU13_MSK                  (1 << PT1PU_PU13)
#define PT1PU_PU13_ENABLE               (1 << PT1PU_PU13)
#define PT1PU_PU13_DISABLE              (1 << PT1PU_PU13)//(0 << PT1PU_PU13)/modify 20210810

#define PT1PU_PU14                       4
#define PT1PU_PU14_MSK                  (1 << PT1PU_PU14)
#define PT1PU_PU14_ENABLE               (1 << PT1PU_PU14)
#define PT1PU_PU14_DISABLE              (1 << PT1PU_PU14)//(0 << PT1PU_PU14)/modify 20210810

#define PT1PU_PU15                       5
#define PT1PU_PU15_MSK                  (1 << PT1PU_PU15)
#define PT1PU_PU15_ENABLE               (1 << PT1PU_PU15)
#define PT1PU_PU15_DISABLE              (1 << PT1PU_PU15)//(0 << PT1PU_PU15)/modify 20210810

#define PT1PU_PU16                       6
#define PT1PU_PU16_MSK                  (1 << PT1PU_PU16)
#define PT1PU_PU16_ENABLE               (1 << PT1PU_PU16)
#define PT1PU_PU16_DISABLE              (1 << PT1PU_PU16)//(0 << PT1PU_PU16)/modify 20210810

#define PT1PU_PU17                       7
#define PT1PU_PU17_MSK                  (1 << PT1PU_PU17)
#define PT1PU_PU17_ENABLE               (1 << PT1PU_PU17)
#define PT1PU_PU17_DISABLE              (1 << PT1PU_PU17)//(0 << PT1PU_PU17)/modify 20210810

// PT1M1 //
#define PT1M1_INTEG0                     0
#define PT1M1_INTEG0_MSK                (3 << PT1M1_INTEG0)
#define PT1M1_INTEG0_LEV_               (3 << PT1M1_INTEG0)
#define PT1M1_INTEG0_LEV                (2 << PT1M1_INTEG0)
#define PT1M1_INTEG0_EDGERISE           (1 << PT1M1_INTEG0)
#define PT1M1_INTEG0_EDGEFALL           (0 << PT1M1_INTEG0)

#define PT1M1_INTEG1                     2
#define PT1M1_INTEG1_MSK                (3 << PT1M1_INTEG1)
#define PT1M1_INTEG1_LEV_               (3 << PT1M1_INTEG1)
#define PT1M1_INTEG1_LEV                (2 << PT1M1_INTEG1)
#define PT1M1_INTEG1_EDGERISE           (1 << PT1M1_INTEG1)
#define PT1M1_INTEG1_EDGEFALL           (0 << PT1M1_INTEG1)

// PT1M2 //
#define PT1M2_PM14                       0
#define PT1M2_PM14_MSK                  (1 << PT1M2_PM14)
#define PT1M2_PM14_TX                   (1 << PT1M2_PM14)
#define PT1M2_PM14_GPIO                 (0 << PT1M2_PM14)

#define PT1M2_PM15                       2
#define PT1M2_PM15_MSK                  (1 << PT1M2_PM15)
#define PT1M2_PM15_SDO                  (1 << PT1M2_PM15)
#define PT1M2_PM15_GPIO                 (0 << PT1M2_PM15)

#define PT1M2_PM16                       4
#define PT1M2_PM16_MSK                  (1 << PT1M2_PM16)
#define PT1M2_PM16_SCK                  (1 << PT1M2_PM16)
#define PT1M2_PM16_GPIO                 (0 << PT1M2_PM16)

#define PT1M2_PM17                       6
#define PT1M2_PM17_MSK                  (1 << PT1M2_PM17)
#define PT1M2_PM17_BZ                   (1 << PT1M2_PM17)
#define PT1M2_PM17_GPIO                 (0 << PT1M2_PM17)

// PT1INT //
#define PT1INT_INTEG2                    2
#define PT1INT_INTEG2_MSK               (1 << PT1INT_INTEG2)
#define PT1INT_INTEG2_EDGERISE          (1 << PT1INT_INTEG2)
#define PT1INT_INTEG2_EDGEFALL          (0 << PT1INT_INTEG2)

#define PT1INT_INTEG3                    3
#define PT1INT_INTEG3_MSK               (1 << PT1INT_INTEG3)
#define PT1INT_INTEG3_EDGERISE          (1 << PT1INT_INTEG3)
#define PT1INT_INTEG3_EDGEFALL          (0 << PT1INT_INTEG3)

#define PT1INT_INTEG4                    4
#define PT1INT_INTEG4_MSK               (1 << PT1INT_INTEG4)
#define PT1INT_INTEG4_EDGERISE          (1 << PT1INT_INTEG4)
#define PT1INT_INTEG4_EDGEFALL          (0 << PT1INT_INTEG4)

#define PT1INT_INTEG5                    5
#define PT1INT_INTEG5_MSK               (1 << PT1INT_INTEG5)
#define PT1INT_INTEG5_EDGERISE          (1 << PT1INT_INTEG5)
#define PT1INT_INTEG5_EDGEFALL          (0 << PT1INT_INTEG5)

#define PT1INT_INTEG6                    6
#define PT1INT_INTEG6_MSK               (1 << PT1INT_INTEG6)
#define PT1INT_INTEG6_EDGERISE          (1 << PT1INT_INTEG6)
#define PT1INT_INTEG6_EDGEFALL          (0 << PT1INT_INTEG6)

#define PT1INT_INTEG7                    7
#define PT1INT_INTEG7_MSK               (1 << PT1INT_INTEG7)
#define PT1INT_INTEG7_EDGERISE          (1 << PT1INT_INTEG7)
#define PT1INT_INTEG7_EDGEFALL          (0 << PT1INT_INTEG7)

// PT2 //    MUX: GPIO-DIO / EXCK-DI / CPA-AI / PWM-DO / CCP-DI / CPA-DO
#define PT2_PT20                         0
#define PT2_PT20_MSK                    (1 << PT2_PT20)
#define PT2_PT20_H                      (1 << PT2_PT20)
#define PT2_PT20_L                      (1 << PT2_PT20)//(0 << PT2_PT20) modify 20180827

#define PT2_PT21                         1
#define PT2_PT21_MSK                    (1 << PT2_PT21)
#define PT2_PT21_H                      (1 << PT2_PT21)
#define PT2_PT21_L                      (1 << PT2_PT21)//(0 << PT2_PT21) modify 20180827

#define PT2_PT22                         2
#define PT2_PT22_MSK                    (1 << PT2_PT22)
#define PT2_PT22_H                      (1 << PT2_PT22)
#define PT2_PT22_L                      (1 << PT2_PT22)//(0 << PT2_PT22) modify 20180827

#define PT2_PT23                         3
#define PT2_PT23_MSK                    (1 << PT2_PT23)
#define PT2_PT23_H                      (1 << PT2_PT23)
#define PT2_PT23_L                      (1 << PT2_PT23)//(0 << PT2_PT23) modify 20180827

#define PT2_PT24                         4
#define PT2_PT24_MSK                    (1 << PT2_PT24)
#define PT2_PT24_H                      (1 << PT2_PT24)
#define PT2_PT24_L                      (1 << PT2_PT24)//(0 << PT2_PT24) modify 20180827

#define PT2_PT25                         5
#define PT2_PT25_MSK                    (1 << PT2_PT25)
#define PT2_PT25_H                      (1 << PT2_PT25)
#define PT2_PT25_L                      (1 << PT2_PT25)//(0 << PT2_PT25) modify 20180827

#define PT2_PT26                         6
#define PT2_PT26_MSK                    (1 << PT2_PT26)
#define PT2_PT26_H                      (1 << PT2_PT26)
#define PT2_PT26_L                      (1 << PT2_PT26)//(0 << PT2_PT26) modify 20180827

#define PT2_PT27                         7
#define PT2_PT27_MSK                    (1 << PT2_PT27)
#define PT2_PT27_H                      (1 << PT2_PT27)
#define PT2_PT27_L                      (1 << PT2_PT27)//(0 << PT2_PT27) modify 20180827

// TRISC2 //
#define TRISC2_TC20                      0
#define TRISC2_TC20_MSK                 (1 << TRISC2_TC20)
#define TRISC2_TC20_OUTPUT              (1 << TRISC2_TC20)
#define TRISC2_TC20_INPUT               (1 << TRISC2_TC20)//(0 << TRISC2_TC20)/modify 20210810

#define TRISC2_TC21                      1
#define TRISC2_TC21_MSK                 (1 << TRISC2_TC21)
#define TRISC2_TC21_OUTPUT              (1 << TRISC2_TC21)
#define TRISC2_TC21_INPUT               (1 << TRISC2_TC21)//(0 << TRISC2_TC21)/modify 20210810

#define TRISC2_TC22                      2
#define TRISC2_TC22_MSK                 (1 << TRISC2_TC22)
#define TRISC2_TC22_OUTPUT              (1 << TRISC2_TC22)
#define TRISC2_TC22_INPUT               (1 << TRISC2_TC22)//(0 << TRISC2_TC22)/modify 20210810

#define TRISC2_TC23                      3
#define TRISC2_TC23_MSK                 (1 << TRISC2_TC23)
#define TRISC2_TC23_OUTPUT              (1 << TRISC2_TC23)
#define TRISC2_TC23_INPUT               (1 << TRISC2_TC23)//(0 << TRISC2_TC23)/modify 20210810

#define TRISC2_TC24                      4
#define TRISC2_TC24_MSK                 (1 << TRISC2_TC24)
#define TRISC2_TC24_OUTPUT              (1 << TRISC2_TC24)
#define TRISC2_TC24_INPUT               (1 << TRISC2_TC24)//(0 << TRISC2_TC24)/modify 20210810

#define TRISC2_TC25                      5
#define TRISC2_TC25_MSK                 (1 << TRISC2_TC25)
#define TRISC2_TC25_OUTPUT              (1 << TRISC2_TC25)
#define TRISC2_TC25_INPUT               (1 << TRISC2_TC25)//(0 << TRISC2_TC25)/modify 20210810

#define TRISC2_TC26                      6
#define TRISC2_TC26_MSK                 (1 << TRISC2_TC26)
#define TRISC2_TC26_OUTPUT              (1 << TRISC2_TC26)
#define TRISC2_TC26_INPUT               (1 << TRISC2_TC26)//(0 << TRISC2_TC26)/modify 20210810

#define TRISC2_TC27                      7
#define TRISC2_TC27_MSK                 (1 << TRISC2_TC27)
#define TRISC2_TC27_OUTPUT              (1 << TRISC2_TC27)
#define TRISC2_TC27_INPUT               (1 << TRISC2_TC27)//(0 << TRISC2_TC27)/modify 20210810

// PT2PU //
#define PT2PU_PU20                       0
#define PT2PU_PU20_MSK                  (1 << PT2PU_PU20)
#define PT2PU_PU20_ENABLE               (1 << PT2PU_PU20)
#define PT2PU_PU20_DISABLE              (1 << PT2PU_PU20)//(0 << PT2PU_PU20)/modify 20210810

#define PT2PU_PU21                       1
#define PT2PU_PU21_MSK                  (1 << PT2PU_PU21)
#define PT2PU_PU21_ENABLE               (1 << PT2PU_PU21)
#define PT2PU_PU21_DISABLE              (1 << PT2PU_PU21)//(0 << PT2PU_PU21)/modify 20210810

#define PT2PU_PU22                       2
#define PT2PU_PU22_MSK                  (1 << PT2PU_PU22)
#define PT2PU_PU22_ENABLE               (1 << PT2PU_PU22)
#define PT2PU_PU22_DISABLE              (1 << PT2PU_PU22)//(0 << PT2PU_PU22)/modify 20210810

#define PT2PU_PU23                       3
#define PT2PU_PU23_MSK                  (1 << PT2PU_PU23)
#define PT2PU_PU23_ENABLE               (1 << PT2PU_PU23)
#define PT2PU_PU23_DISABLE              (1 << PT2PU_PU23)//(0 << PT2PU_PU23)/modify 20210810

#define PT2PU_PU24                       4
#define PT2PU_PU24_MSK                  (1 << PT2PU_PU24)
#define PT2PU_PU24_ENABLE               (1 << PT2PU_PU24)
#define PT2PU_PU24_DISABLE              (1 << PT2PU_PU24)//(0 << PT2PU_PU24)/modify 20210810

#define PT2PU_PU25                       5
#define PT2PU_PU25_MSK                  (1 << PT2PU_PU25)
#define PT2PU_PU25_ENABLE               (1 << PT2PU_PU25)
#define PT2PU_PU25_DISABLE              (1 << PT2PU_PU25)//(0 << PT2PU_PU25)/modify 20210810

#define PT2PU_PU26                       6
#define PT2PU_PU26_MSK                  (1 << PT2PU_PU26)
#define PT2PU_PU26_ENABLE               (1 << PT2PU_PU26)
#define PT2PU_PU26_DISABLE              (1 << PT2PU_PU26)//(0 << PT2PU_PU26)/modify 20210810

#define PT2PU_PU27                       7
#define PT2PU_PU27_MSK                  (1 << PT2PU_PU27)
#define PT2PU_PU27_ENABLE               (1 << PT2PU_PU27)
#define PT2PU_PU27_DISABLE              (1 << PT2PU_PU27)//(0 << PT2PU_PU27)/modify 20210810

// PT2DA //
#define PT2DA_DA22                       2
#define PT2DA_DA22_MSK                  (1 << PT2DA_DA22)
#define PT2DA_DA22_CPAI0                (1 << PT2DA_DA22)
#define PT2DA_DA22_DIG                  (1 << PT2DA_DA22)//(0 << PT2DA_DA22)/modify 20210810

#define PT2DA_DA23                       3
#define PT2DA_DA23_MSK                  (1 << PT2DA_DA23)
#define PT2DA_DA23_CPAI1                (1 << PT2DA_DA23)
#define PT2DA_DA23_DIG                  (1 << PT2DA_DA23)//(0 << PT2DA_DA23)/modify 20210810

#define PT2DA_DA24                       4
#define PT2DA_DA24_MSK                  (1 << PT2DA_DA24)
#define PT2DA_DA24_CPAI2                (1 << PT2DA_DA24)
#define PT2DA_DA24_DIG                  (1 << PT2DA_DA24)//(0 << PT2DA_DA24)/modify 20210810

#define PT2DA_DA25                       5
#define PT2DA_DA25_MSK                  (1 << PT2DA_DA25)
#define PT2DA_DA25_CPAI3                (1 << PT2DA_DA25)
#define PT2DA_DA25_DIG                  (1 << PT2DA_DA25)//(0 << PT2DA_DA25)/modify 20210810

#define PT2DA_DA26                       6
#define PT2DA_DA26_MSK                  (1 << PT2DA_DA26)
#define PT2DA_DA26_CPAI4                (1 << PT2DA_DA26)
#define PT2DA_DA26_DIG                  (1 << PT2DA_DA26)//(0 << PT2DA_DA26)/modify 20210810

#define PT2DA_DA27                       7
#define PT2DA_DA27_MSK                  (1 << PT2DA_DA27)
#define PT2DA_DA27_CPAI5                (1 << PT2DA_DA27)
#define PT2DA_DA27_DIG                  (1 << PT2DA_DA27)//(0 << PT2DA_DA27)/modify 20210810

// PT2M1 //
#define PT2M1_PM22                       4
#define PT2M1_PM22_MSK                  (3 << PT2M1_PM22)
#define PT2M1_PM22_PFD                  (2 << PT2M1_PM22)
#define PT2M1_PM22_PWM0                 (1 << PT2M1_PM22)
#define PT2M1_PM22_GPIO                 (0 << PT2M1_PM22)

#define PT2M1_PM23                       6
#define PT2M1_PM23_MSK                  (1 << PT2M1_PM23)
#define PT2M1_PM23_PWM1                 (1 << PT2M1_PM23)
#define PT2M1_PM23_GPIO                 (0 << PT2M1_PM23)

// PT2M2 //
#define PT2M2_PM24                       0
#define PT2M2_PM24_MSK                  (3 << PT2M2_PM24)
#define PT2M2_PM24_CCP0                 (2 << PT2M2_PM24)
#define PT2M2_PM24_PWM2                 (1 << PT2M2_PM24)
#define PT2M2_PM24_GPIO                 (0 << PT2M2_PM24)

#define PT2M2_PM25                       2
#define PT2M2_PM25_MSK                  (3 << PT2M2_PM25)
#define PT2M2_PM25_CCP1                 (2 << PT2M2_PM25)
#define PT2M2_PM25_PWM3                 (1 << PT2M2_PM25)
#define PT2M2_PM25_GPIO                 (0 << PT2M2_PM25)

#define PT2M2_PM26                       4
#define PT2M2_PM26_MSK                  (1 << PT2M2_PM26)
#define PT2M2_PM26_CPAO                 (1 << PT2M2_PM26)
#define PT2M2_PM26_GPIO                 (0 << PT2M2_PM26)

#define PT2M2_PM27                       6
#define PT2M2_PM27_MSK                  (1 << PT2M2_PM27)
#define PT2M2_PM27_CPAO                 (1 << PT2M2_PM27)
#define PT2M2_PM27_GPIO                 (0 << PT2M2_PM27)

// PT3 //  GPIO-DIO
#define PT3_PT30                         0
#define PT3_PT30_MSK                    (1 << PT3_PT30)
#define PT3_PT30_H                      (1 << PT3_PT30)
#define PT3_PT30_L                      (1 << PT3_PT30)//(0 << PT3_PT30) modify 20180827

#define PT3_PT31                         1
#define PT3_PT31_MSK                    (1 << PT3_PT31)
#define PT3_PT31_H                      (1 << PT3_PT31)
#define PT3_PT31_L                      (1 << PT3_PT31)//(0 << PT3_PT31) modify 20180827

#define PT3_PT32                         2
#define PT3_PT32_MSK                    (1 << PT3_PT32)
#define PT3_PT32_H                      (1 << PT3_PT32)
#define PT3_PT32_L                      (1 << PT3_PT32)//(0 << PT3_PT32) modify 20180827

#define PT3_PT33                         3
#define PT3_PT33_MSK                    (1 << PT3_PT33)
#define PT3_PT33_H                      (1 << PT3_PT33)
#define PT3_PT33_L                      (1 << PT3_PT33)//(0 << PT3_PT33) modify 20180827

#define PT3_PT34                         4
#define PT3_PT34_MSK                    (1 << PT3_PT34)
#define PT3_PT34_H                      (1 << PT3_PT34)
#define PT3_PT34_L                      (1 << PT3_PT34)//(0 << PT3_PT34) modify 20180827

#define PT3_PT35                         5
#define PT3_PT35_MSK                    (1 << PT3_PT35)
#define PT3_PT35_H                      (1 << PT3_PT35)
#define PT3_PT35_L                      (1 << PT3_PT35)//(0 << PT3_PT35) modify 20180827

#define PT3_PT36                         6
#define PT3_PT36_MSK                    (1 << PT3_PT36)
#define PT3_PT36_H                      (1 << PT3_PT36)
#define PT3_PT36_L                      (1 << PT3_PT36)//(0 << PT3_PT36) modify 20180827

#define PT3_PT37                         7
#define PT3_PT37_MSK                    (1 << PT3_PT37)
#define PT3_PT37_H                      (1 << PT3_PT37)
#define PT3_PT37_L                      (1 << PT3_PT37)//(0 << PT3_PT37) modify 20180827

// TRISC3 //
#define TRISC3_TC30                      0
#define TRISC3_TC30_MSK                 (1 << TRISC3_TC30)
#define TRISC3_TC30_OUTPUT              (1 << TRISC3_TC30)
#define TRISC3_TC30_INPUT               (1 << TRISC3_TC30)//(0 << TRISC3_TC30)/modify 20210810

#define TRISC3_TC31                      1
#define TRISC3_TC31_MSK                 (1 << TRISC3_TC31)
#define TRISC3_TC31_OUTPUT              (1 << TRISC3_TC31)
#define TRISC3_TC31_INPUT               (1 << TRISC3_TC31)//(0 << TRISC3_TC31)/modify 20210810

#define TRISC3_TC32                      2
#define TRISC3_TC32_MSK                 (1 << TRISC3_TC32)
#define TRISC3_TC32_OUTPUT              (1 << TRISC3_TC32)
#define TRISC3_TC32_INPUT               (1 << TRISC3_TC32)//(0 << TRISC3_TC32)/modify 20210810

#define TRISC3_TC33                      3
#define TRISC3_TC33_MSK                 (1 << TRISC3_TC33)
#define TRISC3_TC33_OUTPUT              (1 << TRISC3_TC33)
#define TRISC3_TC33_INPUT               (1 << TRISC3_TC33)//(0 << TRISC3_TC33)/modify 20210810

#define TRISC3_TC34                      4
#define TRISC3_TC34_MSK                 (1 << TRISC3_TC34)
#define TRISC3_TC34_OUTPUT              (1 << TRISC3_TC34)
#define TRISC3_TC34_INPUT               (1 << TRISC3_TC34)//(0 << TRISC3_TC34)/modify 20210810

#define TRISC3_TC35                      5
#define TRISC3_TC35_MSK                 (1 << TRISC3_TC35)
#define TRISC3_TC35_OUTPUT              (1 << TRISC3_TC35)
#define TRISC3_TC35_INPUT               (1 << TRISC3_TC35)//(0 << TRISC3_TC35)/modify 20210810

#define TRISC3_TC36                      6
#define TRISC3_TC36_MSK                 (1 << TRISC3_TC36)
#define TRISC3_TC36_OUTPUT              (1 << TRISC3_TC36)
#define TRISC3_TC36_INPUT               (1 << TRISC3_TC36)//(0 << TRISC3_TC36)/modify 20210810

#define TRISC3_TC37                      7
#define TRISC3_TC37_MSK                 (1 << TRISC3_TC37)
#define TRISC3_TC37_OUTPUT              (1 << TRISC3_TC37)
#define TRISC3_TC37_INPUT               (1 << TRISC3_TC37)//(0 << TRISC3_TC37)/modify 20210810

// PT3PU //
#define PT3PU_PU30                       0
#define PT3PU_PU30_MSK                  (1 << PT3PU_PU30)
#define PT3PU_PU30_ENABLE               (1 << PT3PU_PU30)
#define PT3PU_PU30_DISABLE              (1 << PT3PU_PU30)//(0 << PT3PU_PU30)/modify 20210810

#define PT3PU_PU31                       1
#define PT3PU_PU31_MSK                  (1 << PT3PU_PU31)
#define PT3PU_PU31_ENABLE               (1 << PT3PU_PU31)
#define PT3PU_PU31_DISABLE              (1 << PT3PU_PU31)//(0 << PT3PU_PU31)/modify 20210810

#define PT3PU_PU32                       2
#define PT3PU_PU32_MSK                  (1 << PT3PU_PU32)
#define PT3PU_PU32_ENABLE               (1 << PT3PU_PU32)
#define PT3PU_PU32_DISABLE              (1 << PT3PU_PU32)//(0 << PT3PU_PU32)/modify 20210810

#define PT3PU_PU33                       3
#define PT3PU_PU33_MSK                  (1 << PT3PU_PU33)
#define PT3PU_PU33_ENABLE               (1 << PT3PU_PU33)
#define PT3PU_PU33_DISABLE              (1 << PT3PU_PU33)//(0 << PT3PU_PU33)/modify 20210810

#define PT3PU_PU34                       4
#define PT3PU_PU34_MSK                  (1 << PT3PU_PU34)
#define PT3PU_PU34_ENABLE               (1 << PT3PU_PU34)
#define PT3PU_PU34_DISABLE              (1 << PT3PU_PU34)//(0 << PT3PU_PU34)/modify 20210810

#define PT3PU_PU35                       5
#define PT3PU_PU35_MSK                  (1 << PT3PU_PU35)
#define PT3PU_PU35_ENABLE               (1 << PT3PU_PU35)
#define PT3PU_PU35_DISABLE              (1 << PT3PU_PU35)//(0 << PT3PU_PU35)/modify 20210810

#define PT3PU_PU36                       6
#define PT3PU_PU36_MSK                  (1 << PT3PU_PU36)
#define PT3PU_PU36_ENABLE               (1 << PT3PU_PU36)
#define PT3PU_PU36_DISABLE              (1 << PT3PU_PU36)//(0 << PT3PU_PU36)/modify 20210810

#define PT3PU_PU37                       7
#define PT3PU_PU37_MSK                  (1 << PT3PU_PU37)
#define PT3PU_PU37_ENABLE               (1 << PT3PU_PU37)
#define PT3PU_PU37_DISABLE              (1 << PT3PU_PU37)//(0 << PT3PU_PU37)/modify 20210810

// PT4 //  MUX: GPIO:DI / ADC-AI
#define PT4_PT40                         0
#define PT4_PT40_MSK                    (1 << PT4_PT40)
#define PT4_PT40_H                      (1 << PT4_PT40)
#define PT4_PT40_L                      (0 << PT4_PT40)

#define PT4_PT41                         1
#define PT4_PT41_MSK                    (1 << PT4_PT41)
#define PT4_PT41_H                      (1 << PT4_PT41)
#define PT4_PT41_L                      (0 << PT4_PT41)

#define PT4_PT42                         2
#define PT4_PT42_MSK                    (1 << PT4_PT42)
#define PT4_PT42_H                      (1 << PT4_PT42)
#define PT4_PT42_L                      (0 << PT4_PT42)

#define PT4_PT43                         3
#define PT4_PT43_MSK                    (1 << PT4_PT43)
#define PT4_PT43_H                      (1 << PT4_PT43)
#define PT4_PT43_L                      (0 << PT4_PT43)

#define PT4_PT44                         4
#define PT4_PT44_MSK                    (1 << PT4_PT44)
#define PT4_PT44_H                      (1 << PT4_PT44)
#define PT4_PT44_L                      (0 << PT4_PT44)

#define PT4_PT45                         5
#define PT4_PT45_MSK                    (1 << PT4_PT45)
#define PT4_PT45_H                      (1 << PT4_PT45)
#define PT4_PT45_L                      (0 << PT4_PT45)

#define PT4_PT46                         6
#define PT4_PT46_MSK                    (1 << PT4_PT46)
#define PT4_PT46_H                      (1 << PT4_PT46)
#define PT4_PT46_L                      (0 << PT4_PT46)

#define PT4_PT47                         7
#define PT4_PT47_MSK                    (1 << PT4_PT47)
#define PT4_PT47_H                      (1 << PT4_PT47)
#define PT4_PT47_L                      (0 << PT4_PT47)

// PT4DA //
#define PT4DA_DA40                       0
#define PT4DA_DA40_MSK                  (1 << PT4DA_DA40)
#define PT4DA_DA40_AI0                  (1 << PT4DA_DA40)
#define PT4DA_DA40_DIG                  (1 << PT4DA_DA40)//(0 << PT4DA_DA40)/modify 20210810

#define PT4DA_DA41                       1
#define PT4DA_DA41_MSK                  (1 << PT4DA_DA41)
#define PT4DA_DA41_AI1                  (1 << PT4DA_DA41)
#define PT4DA_DA41_DIG                  (1 << PT4DA_DA41)//(0 << PT4DA_DA41)/modify 20210810

#define PT4DA_DA42                       2
#define PT4DA_DA42_MSK                  (1 << PT4DA_DA42)
#define PT4DA_DA42_AI2                  (1 << PT4DA_DA42)
#define PT4DA_DA42_DIG                  (1 << PT4DA_DA42)//(0 << PT4DA_DA42)/modify 20210810

#define PT4DA_DA43                       3
#define PT4DA_DA43_MSK                  (1 << PT4DA_DA43)
#define PT4DA_DA43_AI3                  (1 << PT4DA_DA43)
#define PT4DA_DA43_DIG                  (1 << PT4DA_DA43)//(0 << PT4DA_DA43)/modify 20210810

#define PT4DA_DA44                       4
#define PT4DA_DA44_MSK                  (1 << PT4DA_DA44)
#define PT4DA_DA44_AI4                  (1 << PT4DA_DA44)
#define PT4DA_DA44_DIG                  (1 << PT4DA_DA44)//(0 << PT4DA_DA44)/modify 20210810

#define PT4DA_DA45                       5
#define PT4DA_DA45_MSK                  (1 << PT4DA_DA45)
#define PT4DA_DA45_AI5                  (1 << PT4DA_DA45)
#define PT4DA_DA45_DIG                  (1 << PT4DA_DA45)//(0 << PT4DA_DA45)/modify 20210810

#define PT4DA_DA46                       6
#define PT4DA_DA46_MSK                  (1 << PT4DA_DA46)
#define PT4DA_DA46_AI6                  (1 << PT4DA_DA46)
#define PT4DA_DA46_DIG                  (1 << PT4DA_DA46)//(0 << PT4DA_DA46)/modify 20210810

#define PT4DA_DA47                       7
#define PT4DA_DA47_MSK                  (1 << PT4DA_DA47)
#define PT4DA_DA47_AI7                  (1 << PT4DA_DA47)
#define PT4DA_DA47_DIG                  (1 << PT4DA_DA47)//(0 << PT4DA_DA47)/modify 20210810

// PT4PU //
#define PT4PU_PU40                       0
#define PT4PU_PU40_MSK                  (1 << PT4PU_PU40)
#define PT4PU_PU40_ENABLE               (1 << PT4PU_PU40)
#define PT4PU_PU40_DISABLE              (1 << PT4PU_PU40)//(0 << PT4PU_PU40)/modify 20210810

#define PT4PU_PU41                       1
#define PT4PU_PU41_MSK                  (1 << PT4PU_PU41)
#define PT4PU_PU41_ENABLE               (1 << PT4PU_PU41)
#define PT4PU_PU41_DISABLE              (1 << PT4PU_PU41)//(0 << PT4PU_PU41)/modify 20210810

#define PT4PU_PU42                       2
#define PT4PU_PU42_MSK                  (1 << PT4PU_PU42)
#define PT4PU_PU42_ENABLE               (1 << PT4PU_PU42)
#define PT4PU_PU42_DISABLE              (1 << PT4PU_PU42)//(0 << PT4PU_PU42)/modify 20210810

#define PT4PU_PU43                       3
#define PT4PU_PU43_MSK                  (1 << PT4PU_PU43)
#define PT4PU_PU43_ENABLE               (1 << PT4PU_PU43)
#define PT4PU_PU43_DISABLE              (1 << PT4PU_PU43)//(0 << PT4PU_PU43)/modify 20210810

#define PT4PU_PU44                       4
#define PT4PU_PU44_MSK                  (1 << PT4PU_PU44)
#define PT4PU_PU44_ENABLE               (1 << PT4PU_PU44)
#define PT4PU_PU44_DISABLE              (1 << PT4PU_PU44)//(0 << PT4PU_PU44)/modify 20210810

#define PT4PU_PU45                       5
#define PT4PU_PU45_MSK                  (1 << PT4PU_PU45)
#define PT4PU_PU45_ENABLE               (1 << PT4PU_PU45)
#define PT4PU_PU45_DISABLE              (1 << PT4PU_PU45)//(0 << PT4PU_PU45)/modify 20210810

#define PT4PU_PU46                       6
#define PT4PU_PU46_MSK                  (1 << PT4PU_PU46)
#define PT4PU_PU46_ENABLE               (1 << PT4PU_PU46)
#define PT4PU_PU46_DISABLE              (1 << PT4PU_PU46)//(0 << PT4PU_PU46)/modify 20210810

#define PT4PU_PU47                       7
#define PT4PU_PU47_MSK                  (1 << PT4PU_PU47)
#define PT4PU_PU47_ENABLE               (1 << PT4PU_PU47)
#define PT4PU_PU47_DISABLE              (1 << PT4PU_PU47)//(0 << PT4PU_PU47)/modify 20210810

// PT5 //  GPIO-DI / ADC-AI
#define PT5_PT50                         0
#define PT5_PT50_MSK                    (1 << PT5_PT50)
#define PT5_PT50_H                      (1 << PT5_PT50)
#define PT5_PT50_L                      (1 << PT5_PT50)

#define PT5_PT51                         1
#define PT5_PT51_MSK                    (1 << PT5_PT51)
#define PT5_PT51_H                      (1 << PT5_PT51)
#define PT5_PT51_L                      (1 << PT5_PT51)

#define PT5_PT52                         2
#define PT5_PT52_MSK                    (1 << PT5_PT52)
#define PT5_PT52_H                      (1 << PT5_PT52)
#define PT5_PT52_L                      (1 << PT5_PT52)

#define PT5_PT53                         3
#define PT5_PT53_MSK                    (1 << PT5_PT53)
#define PT5_PT53_H                      (1 << PT5_PT53)
#define PT5_PT53_L                      (0 << PT5_PT53)

#define PT5_PT54                         4
#define PT5_PT54_MSK                    (1 << PT5_PT54)
#define PT5_PT54_H                      (1 << PT5_PT54)
#define PT5_PT54_L                      (0 << PT5_PT54)

#define PT5_PT55                         5
#define PT5_PT55_MSK                    (1 << PT5_PT55)
#define PT5_PT55_H                      (1 << PT5_PT55)
#define PT5_PT55_L                      (0 << PT5_PT55)

#define PT5_PT56                         6
#define PT5_PT56_MSK                    (1 << PT5_PT56)
#define PT5_PT56_H                      (1 << PT5_PT56)
#define PT5_PT56_L                      (0 << PT5_PT56)

#define PT5_PT57                         7
#define PT5_PT57_MSK                    (1 << PT5_PT57)
#define PT5_PT57_H                      (1 << PT5_PT57)
#define PT5_PT57_L                      (0 << PT5_PT57)

// PT5DA //
#define PT5DA_DA50                       0
#define PT5DA_DA50_MSK                  (1 << PT5DA_DA50)
#define PT5DA_DA50_AI8                  (1 << PT5DA_DA50)
#define PT5DA_DA50_DIG                  (1 << PT5DA_DA50)//(0 << PT5DA_DA50)/modify 20210810

#define PT5DA_DA51                       1
#define PT5DA_DA51_MSK                  (1 << PT5DA_DA51)
#define PT5DA_DA51_AI9                  (1 << PT5DA_DA51)
#define PT5DA_DA51_DIG                  (1 << PT5DA_DA51)//(0 << PT5DA_DA51)/modify 20210810

#define PT5DA_DA52                       2
#define PT5DA_DA52_MSK                  (1 << PT5DA_DA52)
#define PT5DA_DA52_AI10                 (1 << PT5DA_DA52)
#define PT5DA_DA52_DIG                  (1 << PT5DA_DA52)//(0 << PT5DA_DA52)/modify 20210810

#define PT5DA_DA53                       3
#define PT5DA_DA53_MSK                  (1 << PT5DA_DA53)
#define PT5DA_DA53_AI11                 (1 << PT5DA_DA53)
#define PT5DA_DA53_DIG                  (1 << PT5DA_DA53)//(0 << PT5DA_DA53)/modify 20210810

// PT5PU //
#define PT5PU_PU50                       0
#define PT5PU_PU50_MSK                  (1 << PT5PU_PU50)
#define PT5PU_PU50_ENABLE               (1 << PT5PU_PU50)
#define PT5PU_PU50_DISABLE              (1 << PT5PU_PU50)//(0 << PT5PU_PU50)/modify 20210810

#define PT5PU_PU51                       1
#define PT5PU_PU51_MSK                  (1 << PT5PU_PU51)
#define PT5PU_PU51_ENABLE               (1 << PT5PU_PU51)
#define PT5PU_PU51_DISABLE              (1 << PT5PU_PU51)//(0 << PT5PU_PU51)/modify 20210810

#define PT5PU_PU52                       2
#define PT5PU_PU52_MSK                  (1 << PT5PU_PU52)
#define PT5PU_PU52_ENABLE               (1 << PT5PU_PU52)
#define PT5PU_PU52_DISABLE              (1 << PT5PU_PU52)//(0 << PT5PU_PU52)/modify 20210810

#define PT5PU_PU53                       3
#define PT5PU_PU53_MSK                  (1 << PT5PU_PU53)
#define PT5PU_PU53_ENABLE               (1 << PT5PU_PU53)
#define PT5PU_PU53_DISABLE              (1 << PT5PU_PU54)//(0 << PT5PU_PU54)/modify 20210810

#define PT5PU_PU54                       4
#define PT5PU_PU54_MSK                  (1 << PT5PU_PU54)
#define PT5PU_PU54_ENABLE               (1 << PT5PU_PU54)
#define PT5PU_PU54_DISABLE              (1 << PT5PU_PU54)//(0 << PT5PU_PU54)/modify 20210810

#define PT5PU_PU55                       5
#define PT5PU_PU55_MSK                  (1 << PT5PU_PU55)
#define PT5PU_PU55_ENABLE               (1 << PT5PU_PU55)
#define PT5PU_PU55_DISABLE              (1 << PT5PU_PU55)//(0 << PT5PU_PU55)/modify 20210810

#define PT5PU_PU56                       6
#define PT5PU_PU56_MSK                  (1 << PT5PU_PU56)
#define PT5PU_PU56_ENABLE               (1 << PT5PU_PU56)
#define PT5PU_PU56_DISABLE              (1 << PT5PU_PU56)//(0 << PT5PU_PU56)/modify 20210810

#define PT5PU_PU57                       7
#define PT5PU_PU57_MSK                  (1 << PT5PU_PU57)
#define PT5PU_PU57_ENABLE               (1 << PT5PU_PU57)
#define PT5PU_PU57_DISABLE              (1 << PT5PU_PU57)//(0 << PT5PU_PU57)/modify 20210810

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
// Peripherals/GPIO Multiplexing Config for Peripherals were placed in each peripheral module
// individually GPIO Config were declared/defined below

#define GPIO_GetPT1Data(PT1Data)             PT1Data=PT1
#define GPIO_GetPT2Data(PT2Data)             PT2Data=PT2
#define GPIO_GetPT3Data(PT3Data)             PT3Data=PT3
#define GPIO_GetPT4Data(PT4Data)             PT4Data=PT4
#define GPIO_GetPT5Data(PT5Data)             PT5Data=PT5


// LNOP AIx //
#define GPIO_AI0Enable()                     (PT4DA |= PT4DA_DA40_AI0)
#define GPIO_AI1Enable()                     (PT4DA |= PT4DA_DA41_AI1)
#define GPIO_AI2Enable()                     (PT4DA |= PT4DA_DA42_AI2)
#define GPIO_AI3Enable()                     (PT4DA |= PT4DA_DA43_AI3)
#define GPIO_AI4Enable()                     (PT4DA |= PT4DA_DA44_AI4)
#define GPIO_AI5Enable()                     (PT4DA |= PT4DA_DA45_AI5)
#define GPIO_AI6Enable()                     (PT4DA |= PT4DA_DA46_AI6)
#define GPIO_AI7Enable()                     (PT4DA |= PT4DA_DA47_AI7)
#define GPIO_AI8Enable()                     (PT5DA |= PT5DA_DA50_AI8)
#define GPIO_AI9Enable()                     (PT5DA |= PT5DA_DA51_AI9)
#define GPIO_AI10Enable()                    (PT5DA |= PT5DA_DA52_AI10)
#define GPIO_AI11Enable()                    (PT5DA |= PT5DA_DA53_AI11)

// ECPA CPAIx //
#define GPIO_CPAI0Enable()                   (PT2DA |= PT2DA_DA22_CPAI0)
#define GPIO_CPAI1Enable()                   (PT2DA |= PT2DA_DA23_CPAI1)
#define GPIO_CPAI2Enable()                   (PT2DA |= PT2DA_DA24_CPAI2)
#define GPIO_CPAI3Enable()                   (PT2DA |= PT2DA_DA25_CPAI3)
#define GPIO_CPAI4Enable()                   (PT2DA |= PT2DA_DA26_CPAI4)
#define GPIO_CPAI5Enable()                   (PT2DA |= PT2DA_DA27_CPAI5)
#define GPIO_CPAI6Enable()                   (PT1DA |= PT1DA_DA10_CPAI6)
#define GPIO_CPAI7Enable()                   (PT1DA |= PT1DA_DA11_CPAI7)
//modify: 20170718
#define GPIO_CPAI0Disable()                   (PT2DA &= (~PT2DA_DA22_CPAI0))
#define GPIO_CPAI1Disable()                   (PT2DA &= (~PT2DA_DA23_CPAI1))
#define GPIO_CPAI2Disable()                   (PT2DA &= (~PT2DA_DA24_CPAI2))
#define GPIO_CPAI3Disable()                   (PT2DA &= (~PT2DA_DA25_CPAI3))
#define GPIO_CPAI4Disable()                   (PT2DA &= (~PT2DA_DA26_CPAI4))
#define GPIO_CPAI5Disable()                   (PT2DA &= (~PT2DA_DA27_CPAI5))
#define GPIO_CPAI6Disable()                   (PT1DA &= (~PT1DA_DA10_CPAI6))
#define GPIO_CPAI7Disable()                   (PT1DA &= (~PT1DA_DA11_CPAI7))

// PT1.x //
#define GPIO_PT1OutputMode(BitSet)           (TRISC1 |= BitSet)
#define GPIO_PT1OutputHigh(BitSet)           (PT1 |= BitSet)
#define GPIO_PT1OutputLow(BitSet)            (PT1 &= ~(BitSet))    // Valid only when PT is Output mode

#define GPIO_PT1InputMode(BitSet)            (TRISC1 &= ~(BitSet))  // GPIO is input as default
#define GPIO_PT1InputPullHight(BitSet)       (PT1PU |= BitSet)
#define GPIO_PT1InputPullHightClear(BitSet)  (PT1PU &= ~(BitSet))   // GPIO is Pull High Disable as default
#define GPIO_PT1AnalogMode(BitSet)           (PT1DA |= BitSet)
#define GPIO_PT1DigitalMode(BitSet)          (PT1DA &= ~(BitSet))   // GPIO is Digital Mode as default

#define BZ_OutEnable()                       (PT1M2 |= PT1M2_PM17_BZ)
#define BZ_OutDisable()                      (PT1M2 &= (~PT1M2_PM17_MSK))

#define GPIO_INTEG0Sel(EG0Sel)               (PT1M1 = ((PT1M1 & (~PT1M1_INTEG0_MSK)) | EG0Sel))
#define GPIO_INTEG1Sel(EG1Sel)               (PT1M1 = ((PT1M1 & (~PT1M1_INTEG1_MSK)) | EG1Sel))
#define GPIO_PM14Sel(PM14Sel)                (PT1M2 = ((PT1M2 & (~PT1M2_PM14_MSK)) | PM14Sel))
#define GPIO_PM15Sel(PM15Sel)                (PT1M2 = ((PT1M2 & (~PT1M2_PM15_MSK)) | PM15Sel))
#define GPIO_PM16Sel(PM16Sel)                (PT1M2 = ((PT1M2 & (~PT1M2_PM16_MSK)) | PM16Sel))
#define GPIO_PM17Sel(PM17Sel)                (PT1M2 = ((PT1M2 & (~PT1M2_PM17_MSK)) | PM17Sel))

// PT2.x //
#define GPIO_PT2OutputMode(BitSet)           (TRISC2 |= BitSet)
#define GPIO_PT2OutputHigh(BitSet)           (PT2 |= BitSet)
#define GPIO_PT2OutputLow(BitSet)            (PT2 &= ~(BitSet))    // Valid only when PT is Output mode

#define GPIO_PT2InputMode(BitSet)            (TRISC2 &= ~(BitSet))  // GPIO is input as default
#define GPIO_PT2InputPullHight(BitSet)       (PT2PU |= BitSet)
#define GPIO_PT2InputPullHightClear(BitSet)  (PT2PU &= ~(BitSet))   // GPIO is Pull High Disable as default

#define GPIO_PM22Sel(PM22Sel)                (PT2M1 = ((PT2M1 & (~PT2M1_PM22_MSK)) | PM22Sel))
#define GPIO_PM23Sel(PM23Sel)                (PT2M1 = ((PT2M1 & (~PT2M1_PM23_MSK)) | PM23Sel))
#define GPIO_PM24Sel(PM24Sel)                (PT2M2 = ((PT2M2 & (~PT2M2_PM24_MSK)) | PM24Sel))
#define GPIO_PM25Sel(PM25Sel)                (PT2M2 = ((PT2M2 & (~PT2M2_PM25_MSK)) | PM25Sel))
#define GPIO_PM26Sel(PM26Sel)                (PT2M2 = ((PT2M2 & (~PT2M2_PM26_MSK)) | PM26Sel))
#define GPIO_PM27Sel(PM27Sel)                (PT2M2 = ((PT2M2 & (~PT2M2_PM27_MSK)) | PM27Sel))


// PT3.x //
#define GPIO_PT3OutputMode(BitSet)           (TRISC3 |= BitSet)
#define GPIO_PT3OutputHigh(BitSet)           (PT3 |= BitSet)
#define GPIO_PT3OutputLow(BitSet)            (PT3 &= ~(BitSet))    // Valid only when PT is Output mode

#define GPIO_PT3InputMode(BitSet)            (TRISC3 &= ~(BitSet))  // GPIO is input as default
#define GPIO_PT3InputPullHight(BitSet)       (PT3PU |= BitSet)
#define GPIO_PT3InputPullHightClear(BitSet)  (PT3PU &= ~(BitSet))   // GPIO is Pull High Disable as default

// PT4.x //
#define GPIO_PT4InputPullHight(BitSet)       (PT4PU |= BitSet)
#define GPIO_PT4InputPullHightClear(BitSet)  (PT4PU &= ~(BitSet))   // GPIO is Pull High Disable as default
#define GPIO_PT4AnalogMode(BitSet)           (PT4DA |= BitSet)   // GPIO is **Analog** Mode as default
#define GPIO_PT4DigitalMode(BitSet)          (PT4DA &= ~(BitSet))

// PT5.x //
#define GPIO_PT5InputPullHight(BitSet)       (PT5PU |= BitSet)
#define GPIO_PT5InputPullHightClear(BitSet)  (PT5PU &= ~(BitSet))   // GPIO is Pull High Disable as default
#define GPIO_PT5AnalogMode(BitSet)           (PT5DA |= BitSet)   // GPIO is **Analog** Mode as default
#define GPIO_PT5DigitalMode(BitSet)          (PT5DA &= ~(BitSet))

// Interrupt //
#define GPIO_INT_Low2BitEnable(L2BSet)       (INTE1 = ((~(INTE1_E0IE_MSK | INTE1_E1IE_MSK)) & INTE1) | L2BSet)   //PT1.0, PT1.1
#define GPIO_INT_Hi6BitEnable(H6BSet)        (INTE3 = ((~(INTE3_E2IE_MSK | INTE3_E3IE_MSK | INTE3_E4IE_MSK | INTE3_E5IE_MSK | INTE3_E6IE_MSK | INTE3_E7IE_MSK)) & INTE3) | (H6BSet<<2)) //PT1.2 ~PT1.7

#define GPIO_INT0_Enable()                   (INTE1 |= INTE1_E0IE_ENABLE)
#define GPIO_INT0_Disable()                  (INTE1 &= (~INTE1_E0IE_MSK))
#define GPIO_INT1_Enable()                   (INTE1 |= INTE1_E1IE_ENABLE)
#define GPIO_INT1_Disable()                  (INTE1 &= (~INTE1_E1IE_MSK))
#define GPIO_INT2_Enable()                   (INTE3 |= INTE3_E2IE_ENABLE)
#define GPIO_INT2_Disable()                  (INTE3 &= (~INTE3_E2IE_MSK))
#define GPIO_INT3_Enable()                   (INTE3 |= INTE3_E3IE_ENABLE)
#define GPIO_INT3_Disable()                  (INTE3 &= (~INTE3_E3IE_MSK))
#define GPIO_INT4_Enable()                   (INTE3 |= INTE3_E4IE_ENABLE)
#define GPIO_INT4_Disable()                  (INTE3 &= (~INTE3_E4IE_MSK))
#define GPIO_INT5_Enable()                   (INTE3 |= INTE3_E5IE_ENABLE)
#define GPIO_INT5_Disable()                  (INTE3 &= (~INTE3_E5IE_MSK))
#define GPIO_INT6_Enable()                   (INTE3 |= INTE3_E6IE_ENABLE)
#define GPIO_INT6_Disable()                  (INTE3 &= (~INTE3_E6IE_MSK))
#define GPIO_INT7_Enable()                   (INTE3 |= INTE3_E7IE_ENABLE)
#define GPIO_INT7_Disable()                  (INTE3 &= (~INTE3_E7IE_MSK))

#define GPIO_INT_TYPE_PT10(PT10INTType)      (PT1M1 = (PT1M1 & (~PT1M1_INTEG0_MSK)) |  PT10INTType) // PT1.0, PT1.1
#define GPIO_INT_TYPE_PT11(PT11INTType)      (PT1M1 = (PT1M1 & (~PT1M1_INTEG1_MSK)) |  PT11INTType) // PT1.0, PT1.1
#define GPIO_INT_TYPE_RISE(BitSet)           (PT1INT |= BitSet)  // PT1.2 ~ PT1.7
#define GPIO_INT_TYPE_FALL(BitSet)           (PT1INT &= ~(BitSet)) // PT1.2 ~ PT1.7

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
void GPIO_OpenPT1Input(unsigned char InputBits,
                       unsigned char PullHighBits);
void GPIO_OpenPT1Ouput(unsigned char OutputBits,
                       unsigned char OutHighBits);
void GPIO_OpenPT2Input(unsigned char InputBits,
                       unsigned char PullHighBits);
void GPIO_OpenPT2Ouput(unsigned char OutputBits,
                       unsigned char OutHighBits);
void GPIO_OpenPT3Input(unsigned char InputBits,
                       unsigned char PullHighBits);
void GPIO_OpenPT3Ouput(unsigned char OutputBits,
                       unsigned char OutHighBits);
void GPIO_OpenPT4Input(unsigned char InputBits,
                       unsigned char PullHighBits);
void GPIO_OpenPT5Input(unsigned char InputBits,
                       unsigned char PullHighBits);
void BZ_Open(unsigned char cks);


