/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// INTE1 //
#define INTE1_GIE                        7
#define INTE1_GIE_MSK                   (1 << INTE1_GIE)
#define INTE1_GIE_ENABLE                (1 << INTE1_GIE)
#define INTE1_GIE_DISABLE               (0 << INTE1_GIE)

#define INTE1_ADCIE                      6
#define INTE1_ADCIE_MSK                 (1 << INTE1_ADCIE)
#define INTE1_ADCIE_ENABLE              (1 << INTE1_ADCIE)
#define INTE1_ADCIE_DISABLE             (0 << INTE1_ADCIE)

#define INTE1_TMCIE                      5
#define INTE1_TMCIE_MSK                 (1 << INTE1_TMCIE)
#define INTE1_TMCIE_ENABLE              (1 << INTE1_TMCIE)
#define INTE1_TMCIE_DISABLE             (0 << INTE1_TMCIE)

#define INTE1_TMBIE                      4
#define INTE1_TMBIE_MSK                 (1 << INTE1_TMBIE)
#define INTE1_TMBIE_ENABLE              (1 << INTE1_TMBIE)
#define INTE1_TMBIE_DISABLE             (0 << INTE1_TMBIE)

#define INTE1_TMAIE                      3
#define INTE1_TMAIE_MSK                 (1 << INTE1_TMAIE)
#define INTE1_TMAIE_ENABLE              (1 << INTE1_TMAIE)
#define INTE1_TMAIE_DISABLE             (0 << INTE1_TMAIE)

#define INTE1_WDTIE                      2
#define INTE1_WDTIE_MSK                 (1 << INTE1_WDTIE)
#define INTE1_WDTIE_ENABLE              (1 << INTE1_WDTIE)
#define INTE1_WDTIE_DISABLE             (0 << INTE1_WDTIE)

#define INTE1_E0IE                       0
#define INTE1_E0IE_MSK                  (1 << INTE1_E0IE)
#define INTE1_E0IE_ENABLE               (1 << INTE1_E0IE)
#define INTE1_E0IE_DISABLE              (0 << INTE1_E0IE)

#define INTE1_E1IE                       1
#define INTE1_E1IE_MSK                  (1 << INTE1_E1IE)
#define INTE1_E1IE_ENABLE               (1 << INTE1_E1IE)
#define INTE1_E1IE_DISABLE              (0 << INTE1_E1IE)

// INTE2 //
#define INTE2_TXIE                       7
#define INTE2_TXIE_MSK                  (1 << INTE2_TXIE)
#define INTE2_TXIE_ENABLE               (1 << INTE2_TXIE)
#define INTE2_TXIE_DISABLE              (0 << INTE2_TXIE)

#define INTE2_RCIE                       6
#define INTE2_RCIE_MSK                  (1 << INTE2_RCIE)
#define INTE2_RCIE_ENABLE               (1 << INTE2_RCIE)
#define INTE2_RCIE_DISABLE              (0 << INTE2_RCIE)

#define INTE2_CPOIE                      3
#define INTE2_CPOIE_MSK                 (1 << INTE2_CPOIE)
#define INTE2_CPOIE_ENABLE              (1 << INTE2_CPOIE)
#define INTE2_CPOIE_DISABLE             (0 << INTE2_CPOIE)

#define INTE2_SSPIE                      2
#define INTE2_SSPIE_MSK                 (1 << INTE2_SSPIE)
#define INTE2_SSPIE_ENABLE              (1 << INTE2_SSPIE)
#define INTE2_SSPIE_DISABLE             (0 << INTE2_SSPIE)

#define INTE2_CCP1IE                     1
#define INTE2_CCP1IE_MSK                (1 << INTE2_CCP1IE)
#define INTE2_CCP1IE_ENABLE             (1 << INTE2_CCP1IE)
#define INTE2_CCP1IE_DISABLE            (0 << INTE2_CCP1IE)

#define INTE2_CCP0IE                     0
#define INTE2_CCP0IE_MSK                (1 << INTE2_CCP0IE)
#define INTE2_CCP0IE_ENABLE             (1 << INTE2_CCP0IE)
#define INTE2_CCP0IE_DISABLE            (0 << INTE2_CCP0IE)

// INTE3 //
#define INTE3_E2IE                       2
#define INTE3_E2IE_MSK                  (1 << INTE3_E2IE)
#define INTE3_E2IE_ENABLE               (1 << INTE3_E2IE)
#define INTE3_E2IE_DISABLE              (0 << INTE3_E2IE)

#define INTE3_E3IE                       3
#define INTE3_E3IE_MSK                  (1 << INTE3_E3IE)
#define INTE3_E3IE_ENABLE               (1 << INTE3_E3IE)
#define INTE3_E3IE_DISABLE              (0 << INTE3_E3IE)

#define INTE3_E4IE                       4
#define INTE3_E4IE_MSK                  (1 << INTE3_E4IE)
#define INTE3_E4IE_ENABLE               (1 << INTE3_E4IE)
#define INTE3_E4IE_DISABLE              (0 << INTE3_E4IE)

#define INTE3_E5IE                       5
#define INTE3_E5IE_MSK                  (1 << INTE3_E5IE)
#define INTE3_E5IE_ENABLE               (1 << INTE3_E5IE)
#define INTE3_E5IE_DISABLE              (0 << INTE3_E5IE)

#define INTE3_E6IE                       6
#define INTE3_E6IE_MSK                  (1 << INTE3_E6IE)
#define INTE3_E6IE_ENABLE               (1 << INTE3_E6IE)
#define INTE3_E6IE_DISABLE              (0 << INTE3_E6IE)

#define INTE3_E7IE                       7
#define INTE3_E7IE_MSK                  (1 << INTE3_E7IE)
#define INTE3_E7IE_ENABLE               (1 << INTE3_E7IE)
#define INTE3_E7IE_DISABLE              (0 << INTE3_E7IE)

// INTF1 //
#define INTF1_ADCIF                      6
#define INTF1_ADCIF_MSK                 (1 << INTF1_ADCIF)
#define INTF1_ADCIF_SET                 (1 << INTF1_ADCIF)

#define INTF1_TMCIF                      5
#define INTF1_TMCIF_MSK                 (1 << INTF1_TMCIF)
#define INTF1_TMCIF_SET                 (1 << INTF1_TMCIF)

#define INTF1_TMBIF                      4
#define INTF1_TMBIF_MSK                 (1 << INTF1_TMBIF)
#define INTF1_TMBIF_SET                 (1 << INTF1_TMBIF)

#define INTF1_TMAIF                      3
#define INTF1_TMAIF_MSK                 (1 << INTF1_TMAIF)
#define INTF1_TMAIF_SET                 (1 << INTF1_TMAIF)

#define INTF1_WDTIF                      2
#define INTF1_WDTIF_MSK                 (1 << INTF1_WDTIF)
#define INTF1_WDTIF_SET                 (1 << INTF1_WDTIF)

#define INTF1_F0IF                       0
#define INTF1_F0IF_MSK                  (1 << INTF1_F0IF)
#define INTF1_F0IF_SET                  (1 << INTF1_F0IF)

#define INTF1_F1IF                       1
#define INTF1_F1IF_MSK                  (1 << INTF1_F1IF)
#define INTF1_F1IF_SET                  (1 << INTF1_F1IF)

// INTF2 //
#define INTF2_TXIF                       7
#define INTF2_TXIF_MSK                  (1 << INTF2_TXIF)
#define INTF2_TXIF_SET                  (1 << INTF2_TXIF)

#define INTF2_RCIF                       6
#define INTF2_RCIF_MSK                  (1 << INTF2_RCIF)
#define INTF2_RCIF_SET                  (1 << INTF2_RCIF)

#define INTF2_CPOIF                      3
#define INTF2_CPOIF_MSK                 (1 << INTF2_CPOIF)
#define INTF2_CPOIF_SET                 (1 << INTF2_CPOIF)

#define INTF2_SSPIF                      2
#define INTF2_SSPIF_MSK                 (1 << INTF2_SSPIF)
#define INTF2_SSPIF_SET                 (1 << INTF2_SSPIF)

#define INTF2_CCP1IF                     1
#define INTF2_CCP1IF_MSK                (1 << INTF2_CCP1IF)
#define INTF2_CCP1IF_SET                (1 << INTF2_CCP1IF)

#define INTF2_CCP0IF                     0
#define INTF2_CCP0IF_MSK                (1 << INTF2_CCP0IF)
#define INTF2_CCP0IF_SET                (1 << INTF2_CCP0IF)

// INTF3 //
#define INTF3_F2IF                       2
#define INTF3_F2IF_MSK                  (1 << INTF3_F2IF)
#define INTF3_F2IF_SET                  (1 << INTF3_F2IF)

#define INTF3_F3IF                       3
#define INTF3_F3IF_MSK                  (1 << INTF3_F3IF)
#define INTF3_F3IF_SET                  (1 << INTF3_F3IF)

#define INTF3_F4IF                       4
#define INTF3_F4IF_MSK                  (1 << INTF3_F4IF)
#define INTF3_F4IF_SET                  (1 << INTF3_F4IF)

#define INTF3_F5IF                       5
#define INTF3_F5IF_MSK                  (1 << INTF3_F5IF)
#define INTF3_F5IF_SET                  (1 << INTF3_F5IF)

#define INTF3_F6IF                       6
#define INTF3_F6IF_MSK                  (1 << INTF3_F6IF)
#define INTF3_F6IF_SET                  (1 << INTF3_F6IF)

#define INTF3_F7IF                       7
#define INTF3_F7IF_MSK                  (1 << INTF3_F7IF)
#define INTF3_F7IF_SET                  (1 << INTF3_F7IF)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define INT_GIE_Enable()                (INTE1 |= INTE1_GIE_ENABLE)
#define INT_GIE_Disable()               (INTE1 &= (~INTE1_GIE_MSK))

#define INT0_Enable()                   (INTE1 |= INTE1_E0IE_ENABLE)
#define INT0_Disable()                  (INTE1 &= (~INTE1_E0IE_MSK))
#define INT0_IsFlag()                   (INTF1 & INTF1_F0IF_SET)
#define INT0_ClearFlag()                (INTF1 &= (~INTF1_F0IF_MSK))
#define INT1_Enable()                   (INTE1 |= INTE1_E1IE_ENABLE)
#define INT1_Disable()                  (INTE1 &= (~INTE1_E1IE_MSK))
#define INT1_IsFlag()                   (INTF1 & INTF1_F1IF_SET)
#define INT1_ClearFlag()                (INTF1 &= (~INTF1_F1IF_MSK))
#define INT2_Enable()                   (INTE3 |= INTE3_E2IE_ENABLE)
#define INT2_Disable()                  (INTE3 &= (~INTE3_E2IE_MSK))
#define INT2_IsFlag()                   (INTF3 & INTF3_F2IF_SET)
#define INT2_ClearFlag()                (INTF3 &= (~INTF3_F2IF_MSK))
#define INT3_Enable()                   (INTE3 |= INTE3_E3IE_ENABLE)
#define INT3_Disable()                  (INTE3 &= (~INTE3_E3IE_MSK))
#define INT3_IsFlag()                   (INTF3 & INTF3_F3IF_SET)
#define INT3_ClearFlag()                (INTF3 &= (~INTF3_F3IF_MSK))
#define INT4_Enable()                   (INTE3 |= INTE3_E4IE_ENABLE)
#define INT4_Disable()                  (INTE3 &= (~INTE3_E4IE_MSK))
#define INT4_IsFlag()                   (INTF3 & INTF3_F4IF_SET)
#define INT4_ClearFlag()                (INTF3 &= (~INTF3_F4IF_MSK))
#define INT5_Enable()                   (INTE3 |= INTE3_E5IE_ENABLE)
#define INT5_Disable()                  (INTE3 &= (~INTE3_E5IE_MSK))
#define INT5_IsFlag()                   (INTF3 & INTF3_F5IF_SET)
#define INT5_ClearFlag()                (INTF3 &= (~INTF3_F5IF_MSK))
#define INT6_Enable()                   (INTE3 |= INTE3_E6IE_ENABLE)
#define INT6_Disable()                  (INTE3 &= (~INTE3_E6IE_MSK))
#define INT6_IsFlag()                   (INTF3 & INTF3_F6IF_SET)
#define INT6_ClearFlag()                (INTF3 &= (~INTF3_F6IF_MSK))
#define INT7_Enable()                   (INTE3 |= INTE3_E7IE_ENABLE)
#define INT7_Disable()                  (INTE3 &= (~INTE3_E7IE_MSK))
#define INT7_IsFlag()                   (INTF3 & INTF3_F7IF_SET)
#define INT7_ClearFlag()                (INTF3 &= (~INTF3_F7IF_MSK))

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
