/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <LNOP1.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: LNOP1_Open                                                                            |
|                                                                                                  |
|  Parameters:                                                                                     |
|         NInput    - [in] OPCN1_OPN_OPO                                                           |
|                          OPCN1_OPN_AI4                                                           |
|                          OPCN1_OPN_AI5                                                           |
|                          OPCN1_OPN_AI6                                                           |
|                          OPCN1_OPN_AI0          *AI0 and AI5 short*                              |
|                          OPCN1_OPN_AI1          *AI1 and AI5 short*                              |
|         PInput    - [in] OPCN1_OPP_AI3                                                           |
|                          OPCN1_OPP_AI7                                                           |
|                          OPCN1_OPP_AI10                                                          |
|                          OPCN1_OPP_AI11                                                          |
|         Chop      - [in] OPCN1_OPM_CHOPPER64                                                     |
|                          OPCN1_OPM_CHOPPER128                                                    |
|                          OPCN1_OPM_FORWARD                                                       |
|                          OPCN1_OPM_REVERSE                                                       |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Low Noise OPAMP1(LNOP1)                                |
|-------------------------------------------------------------------------------------------------*/
void LNOP1_Open(unsigned char NInput, //LNOP1 - end input channel selector
                unsigned char PInput, //LNOP1 + end input channel selector
                unsigned char Chop)  //LNOP1 input processor
{
    LNOP1_Enable();
    LNOP1_OPMode(Chop);
    LNOP1_OPInputN(NInput);
    LNOP1_OPInputP(PInput);
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
