/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy1114Bsfr.h>    // Peripheral Register Memory Mapping
#include "LNOP2.h"

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: LNOP2_Open                                                                            |
|                                                                                                  |
|  Parameters:                                                                                     |
|         NInput    - [in] OPCN2_OPN2_OPO2                                                         |
|                          OPCN2_OPN2_AI4                                                          |
|                          OPCN2_OPN2_AI0         *AI0 and AI5 short*                              |
|                          OPCN2_OPN2_AI1         *AI1 and AI5 short*                              |
|         PInput    - [in] OPCN2_OPP2_AI3                                                          |
|                          OPCN2_OPP2_AI9         *AI9 and AI11 short*                             |
|                          OPCN2_OPP2_AI10        *AI10 and AI11 short*                            |
|                          OPCN2_OPP2_AI2         *AI2 and AI11 short*                             |
|         Chop      - [in] OPCN2_OPM_CHOPPER64                                                     |
|                          OPCN2_OPM_CHOPPER128                                                    |
|                          OPCN2_OPM_FORWARD                                                       |
|                          OPCN2_OPM_REVERSE                                                       |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Low Noise OPAMP2(LNOP2)                                |
|-------------------------------------------------------------------------------------------------*/
void LNOP2_Open(unsigned char NInput, //LNOP2 - end input channel selector
                unsigned char PInput, //LNOP2 + end input channel selector
                unsigned char Chop)  //LNOP2 input processor
{
    LNOP2_Enable();
    LNOP2_OPMode(Chop);
    LNOP2_OPInputN(NInput);
    LNOP2_OPInputP(PInput);
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
