/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// LVDCN //
#define LVDCN_LVDFG                      6
#define LVDCN_LVDFG_MSK                 (1 << LVDCN_LVDFG)
#define LVDCN_LVDFG_ON                  (1 << LVDCN_LVDFG)
#define LVDCN_LVDFG_OFF                 (0 << LVDCN_LVDFG)

#define LVDCN_LVD                        5
#define LVDCN_LVD_MSK                   (1 << LVDCN_LVD)
#define LVDCN_LVD_ON                    (1 << LVDCN_LVD)
#define LVDCN_LVD_OFF                   (0 << LVDCN_LVD)

#define LVDCN_LVDON                      4
#define LVDCN_LVDON_MSK                 (1 << LVDCN_LVDON)
#define LVDCN_LVDON_STABLE              (1 << LVDCN_LVDON)
#define LVDCN_LVDON_UNSTABLE            (0 << LVDCN_LVDON)

#define LVDCN_VLDX                       0
#define LVDCN_VLDX_MSK                  (15 << LVDCN_VLDX)
#define LVDCN_VLDX_LVDIN                (15 << LVDCN_VLDX)
#define LVDCN_VLDX_3V31                 (14 << LVDCN_VLDX)
#define LVDCN_VLDX_3V21                 (13 << LVDCN_VLDX)
#define LVDCN_VLDX_3V11                 (12 << LVDCN_VLDX)
#define LVDCN_VLDX_3V01                 (11 << LVDCN_VLDX)
#define LVDCN_VLDX_2V91                 (10 << LVDCN_VLDX)
#define LVDCN_VLDX_2V81                 (9 << LVDCN_VLDX)
#define LVDCN_VLDX_2V71                 (8 << LVDCN_VLDX)
#define LVDCN_VLDX_2V61                 (7 << LVDCN_VLDX)
#define LVDCN_VLDX_2V51                 (6 << LVDCN_VLDX)
#define LVDCN_VLDX_2V41                 (5 << LVDCN_VLDX)
#define LVDCN_VLDX_2V31                 (4 << LVDCN_VLDX)
#define LVDCN_VLDX_2V21                 (3 << LVDCN_VLDX)
#define LVDCN_VLDX_2V11                 (2 << LVDCN_VLDX)
#define LVDCN_VLDX_2V01                 (1 << LVDCN_VLDX)
#define LVDCN_VLDX_LVDOFF               (0 << LVDCN_VLDX)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define LVD_Open(LVDSel)                (LVDCN = ((LVDCN & (~LVDCN_VLDX_MSK)) | LVDSel))
#define LVD_FGClr()                     (LVDCN &= (~LVDCN_LVDFG_MSK)) //error: add ')';Modify:20170718
#define LVD_IsFlag()                    (LVDCN & LVDCN_LVDFG_ON)
#define LVD_GetStatus()                 (LVDCN & LVDCN_LVD_ON)        //Low voltage response flag
#define LVD_GetLVDON()                  (LVDCN & LVDCN_LVDON_STABLE)  //Low voltage detect circuit stable flag

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
