/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <PWR.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: PWR_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         VDDASel   - [in] PWRCN_VDDAX_3V3     / PWRCN_VDDAX_2V9                                   |
|                          PWRCN_VDDAX_2V6     / PWRCN_VDDAX_2V4                                   |
|         ACMEn     - [in] PWRCN_ENACM_DISABLE / PWRCN_ENACM_ENABLE                                |
|         DelayCnt  - [in] 8-bit Delay Count                                                       |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Power System                                           |
|-------------------------------------------------------------------------------------------------*/
void PWR_Open(unsigned char VDDASel,    //VDDA regulated selector
              unsigned char ACMEn,
              unsigned char DelayCnt)
{
    PWRCN = 0;
    PWRCN = (PWRCN_ENVDDA_ENABLE | VDDASel | ACMEn);
    while(DelayCnt--);
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
