/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// PWRCN //
#define PWRCN_ENVDDA                     7
#define PWRCN_ENVDDA_MSK                (1 << PWRCN_ENVDDA)
#define PWRCN_ENVDDA_ENABLE             (1 << PWRCN_ENVDDA)
#define PWRCN_ENVDDA_DISABLE            (0 << PWRCN_ENVDDA)

#define PWRCN_VDDAX                      5
#define PWRCN_VDDAX_MSK                 (3 << PWRCN_VDDAX)
#define PWRCN_VDDAX_2V4                 (3 << PWRCN_VDDAX)
#define PWRCN_VDDAX_2V6                 (2 << PWRCN_VDDAX)
#define PWRCN_VDDAX_2V9                 (1 << PWRCN_VDDAX)
#define PWRCN_VDDAX_3V3                 (0 << PWRCN_VDDAX)

#define PWRCN_ENACM                      4
#define PWRCN_ENACM_MSK                 (1 << PWRCN_ENACM)
#define PWRCN_ENACM_ENABLE              (1 << PWRCN_ENACM)
#define PWRCN_ENACM_DISABLE             (0 << PWRCN_ENACM)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define PWR_ACMEnable()                 (PWRCN |= PWRCN_ENACM_ENABLE)
#define PWR_ACMDisable()                (PWRCN &= (~PWRCN_ENACM_MSK))

#define PWR_VDDASel(VDDAVSel)           (PWRCN = ((PWRCN & (~PWRCN_VDDAX_MSK)) | VDDAVSel))
#define PWR_VDDAEnable()                (PWRCN |= PWRCN_ENVDDA_ENABLE)//ERROR:PWE_VDDAEnableΪPWR_VDDAEnable2017/9/7
#define PWR_VDDADisable()               (PWRCN &= (~PWRCN_ENVDDA_MSK))

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
void PWR_Open(unsigned char VDDASel,    //VDDA regulated selector
              unsigned char ACMEn,
              unsigned char DelayCnt);
