/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY11P Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// PSTATUS //
#define PSTATUS_PD                       6
#define PSTATUS_PD_MSK                  (1 << PSTATUS_PD)
#define PSTATUS_PD_SLEEP                (1 << PSTATUS_PD)
#define PSTATUS_PD_CLR                  (0 << PSTATUS_PD)

#define PSTATUS_TO                       6
#define PSTATUS_TO_MSK                  (1 << PSTATUS_TO)
#define PSTATUS_TO_WDT                  (1 << PSTATUS_TO)
#define PSTATUS_TO_CLR                  (0 << PSTATUS_TO)

#define PSTATUS_IDLEB                    6
#define PSTATUS_IDLEB_MSK               (1 << PSTATUS_IDLEB)
#define PSTATUS_IDLEB_IDLE              (1 << PSTATUS_IDLEB)
#define PSTATUS_IDLEB_CLR               (0 << PSTATUS_IDLEB)

#define PSTATUS_BOR                      6
#define PSTATUS_BOR_MSK                 (1 << PSTATUS_BOR)
#define PSTATUS_BOR_BOR                 (1 << PSTATUS_BOR)
#define PSTATUS_BOR_CLR                 (0 << PSTATUS_BOR)

#define PSTATUS_SKERR                    6
#define PSTATUS_SKERR_MSK               (1 << PSTATUS_SKERR)
#define PSTATUS_SKERR_ERR               (1 << PSTATUS_SKERR)
#define PSTATUS_SKERR_CLR               (0 << PSTATUS_SKERR)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define Sleep()                         __asm__ ("SLP")   //Sleep Mode
#define Idle()                          __asm__ ("IDLE")  //Idle Mode
#define SYS_ReadSKERR()								 (PSTATUS&PSTATUS_SKERR_ERR)
#define SYS_ReadBOR()							     (PSTATUS&PSTATUS_BOR_BOR)	
#define SYS_ReadIDLE()								 (PSTATUS&PSTATUS_IDLEB_IDLE)	
#define SYS_ReadTO()								   (PSTATUS&PSTATUS_TO_WDT)	
#define SYS_ReadSLEEP()								 (PSTATUS&PSTATUS_PD_SLEEP)
/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
