/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <TMA.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: TMA_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         ck        - [in] TMACN_TMACK_DIV256 / TMACN_TMACK_DIV1                                   |
|         cks       - [in] TMACN_TMAS_DIV4    / TMACN_TMAS_DIV16                                   |
|                          TMACN_TMAS_DIV64   / TMACN_TMAS_DIV256                                  |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Timer-A(TMA)                                           |
|-------------------------------------------------------------------------------------------------*/
void TMA_Open(unsigned char ck,    //Timer-A operating frequency selector
              unsigned char cks)  //Timer-A overflow controller
{
    TMA_CLKSel(ck);
    TMA_OFControlSel(cks);
    TMA_Enable();
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
