/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <TMB.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: TMB_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         ck        - [in] TMBCN_TMBCK_INTRCK / TMBCN_TMBCK_LSCK                                   |
|         cks       - [in] TMBCN_TMBS_DIV1    / TMBCN_TMBS_DIV2                                    |
|                          TMBCN_TMBS_DIV4    / TMBCN_TMBS_DIV8                                    |
|         mode      - [in] TMBCN_TMBR2R_8BIT  / TMBCN_TMBR2R_16BIT                                 |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Timer-B(TMB)                                           |
|-------------------------------------------------------------------------------------------------*/
void TMB_Open(unsigned char ck,         //Timer-B operating frequency select controller
              unsigned char cks,        //Timer-B overflow controller
              unsigned char mode)       //TMBR register operating way
{
    TMB_CLKSel(ck);
    TMB_CLKPrescalerSel(cks);
    TMB_TMBROperateMode(mode);
    TMB_Enable();
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
