/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <TMC.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: TMC_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         tmcck     - [in] TMCCN_TMCCK_INTRCK / TMCCN_TMCCK_LSCK                                   |
|                          TMCCN_TMCCK_TMCKI  / TMCCN_TMCCK_CPAO                                   |
|         tmcs0     - [in] TMCCN_TMCS0_DIV1   / TMCCN_TMCS0_DIV2                                   |
|                          TMCCN_TMCS0_DIV4   / TMCCN_TMCS0_DIV16                                  |
|         tmcs1     - [in] TMCCN_TMCS1_DIV1   / TMCCN_TMCS1_DIV2                                   |
|                          TMCCN_TMCS1_DIV3   / TMCCN_TMCS1_DIV4                                   |
|                          TMCCN_TMCS1_DIV5   / TMCCN_TMCS1_DIV6                                   |
|                          TMCCN_TMCS1_DIV7   / TMCCN_TMCS1_DIV8                                   |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Timer-C(TMC)                                           |
|-------------------------------------------------------------------------------------------------*/
void TMC_Open(unsigned char tmcck, //TMC operating frequency select controller
              unsigned char tmcs0, //Timer-C operating frequency prescaler
              unsigned char tmcs1) //Timer-C counter overflow controller
{
    TMC_CLKSel(tmcck);
    TMC_CLKPrescalerSel(tmcs0);
    TMC_OFControlSel(tmcs1);
    TMC_Enable();
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
