/**************************************************************************************************|
|* Copyright 2016 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy11s14sfr.h>    // Peripheral Register Memory Mapping
#include <WDT.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: WDT_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         wdts      - [in] TMACN_WDTS_2    / TMACN_WDTS_8    / TMACN_WDTS_32   / TMACN_WDTS_128    |
|                          TMACN_WDTS_512  / TMACN_WDTS_2048 / TMACN_WDTS_8192 / TMACN_WDTS_32768  |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Watch Dog Timer(WDT)                                   |
|-------------------------------------------------------------------------------------------------*/
void WDT_Open(unsigned char wdts) //Configure WDT overflow time
{
   WDT_Enable();
   WDT_OFTimeSel(wdts);
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
